import { arrayDifference, dropElement, everyNth, filterNoUnique, flatten, forEachRight, groupBy, init2DArray, intersection, intToBytes2, isSorted, join, longsItem, mapObject, pick, pull, pullAtIndex, pullAtValue, reducedFilter, sample, sampleSize, shuffle, similar, stringToUint8Array, uint8ArrayToString, union } from './package.array';
import { getDaysDiffBetweenDates, getNext, getPrev } from './package.date';
import { delay } from './package.function';
import { size, standardDeviation, sumPower, toDecimal } from './package.math';
import { deleteKey, invertKeyValues, lowercaseKeys, mapKeys, mapValues, merge } from './package.object';
import { capitalize, capitalizeEveryWord, csvDownload, htmlToExcel } from './package.string';
import { isWebUrl, whichBrowers } from './package.web';
export declare const mt: {
    browersWidth: () => number;
    buildUrlParams: (obj: any) => string;
    isWebUrl: typeof isWebUrl;
    parseCookie: (str: string) => any;
    whichBrowers: typeof whichBrowers;
    capitalize: typeof capitalize;
    capitalizeEveryWord: typeof capitalizeEveryWord;
    csvDownload: typeof csvDownload;
    escapeHTML: (str: string) => string;
    escapeRegExp: (str: string) => string;
    firstUniqChar: (s: string) => number;
    fromCamelCase: (str: string, separator?: string) => string;
    getURLParams: (url: string) => {};
    htmlToExcel: typeof htmlToExcel;
    isAbsoluteURL: (str: string) => boolean;
    mask: (cc: string, num?: number, mask?: string) => string;
    randomHexColorCode: () => string;
    reverseString: (str: string) => string;
    serializeCookie: (name: string, val: string) => string;
    sortCharactersInString: (str: string) => string;
    splitLines: (str: string) => string[];
    toCamelCase: (str: string) => string;
    toKebabCase: (str: string) => string;
    toSnakeCase: (str: string) => void;
    unescapeHTML: (str: string) => string;
    words: (str: string, pattern?: RegExp) => string[];
    deleteKey: typeof deleteKey;
    getType: (v: any) => any;
    invertKeyValues: typeof invertKeyValues;
    isArrayLike: (val: any) => false | any[];
    lowercaseKeys: typeof lowercaseKeys;
    mapKeys: typeof mapKeys;
    mapValues: typeof mapValues;
    merge: typeof merge;
    average: (...nums: any[]) => number;
    averageBy: (arr: {
        map: (arg0: any) => {
            reduce: (arg0: (acc: any, val: any) => any, arg1: number) => number;
        };
        length: number;
    }, fn: string | number) => number;
    digitize: (n: any) => number[];
    factorial: (n: number) => 1 | undefined;
    pascal: (numRows: number) => any;
    size: typeof size;
    standardDeviation: typeof standardDeviation;
    sum: (arr: number[]) => number;
    sumPower: typeof sumPower;
    takeTime: (callback: Function) => any;
    toDecimal: typeof toDecimal;
    toSafeInteger: (num: string | number) => number;
    chainAsync: (fns: Function[]) => void;
    compose: (...fns: any[]) => any;
    curry: (fn: any, arity?: any, ...args: any[]) => any;
    delay: typeof delay;
    sleep: (ms: number | undefined) => Promise<{}>;
    dateFormat: (date: Date, sFormat?: String) => string;
    getDaysDiffBetweenDates: typeof getDaysDiffBetweenDates;
    getNext: typeof getNext;
    getPrev: typeof getPrev;
    truthCheckCollection: (collection: any[], pre: string) => boolean;
    all: (arr: any[], fn: import("./package.array").BoolFunction) => boolean;
    allEqual: (arr: any[]) => boolean;
    any: (arr: any[], fn: import("./package.array").BoolFunction) => boolean;
    arrayDifference: typeof arrayDifference;
    arrayToCSV: (arr: any[], delimiter?: string) => string;
    chunk: (arr: any[], size: number) => any[];
    compact: (arr: any[]) => any[];
    countBy: (arr: any, fn: any) => any;
    countOccurrences: (arr: any[], el: any) => number;
    deepFlatten: (arr: any[]) => any[];
    difference: (a: any[], b: any[]) => any[];
    differenceWith: (arr: any[], val: any[], comp: Function) => any[];
    dropElement: typeof dropElement;
    everyNth: typeof everyNth;
    filterNoUnique: typeof filterNoUnique;
    flatten: typeof flatten;
    forEachRight: typeof forEachRight;
    groupBy: typeof groupBy;
    init2DArray: typeof init2DArray;
    intToBytes2: typeof intToBytes2;
    intersect: (nums1: number[], nums2: number[]) => number[];
    intersection: typeof intersection;
    isSorted: typeof isSorted;
    join: typeof join;
    longsItem: typeof longsItem;
    mapObject: typeof mapObject;
    maxProfit: (prices: number[]) => number;
    occurrence: (arr: any[], val: any) => void;
    pick: typeof pick;
    pull: typeof pull;
    pullAtIndex: typeof pullAtIndex;
    pullAtValue: typeof pullAtValue;
    reducedFilter: typeof reducedFilter;
    rotate: (nums: number[], k: number) => void;
    rotateMatrix: (matrix: any) => void;
    sample: typeof sample;
    sampleSize: typeof sampleSize;
    setArray: (arr: any[]) => Set<any>;
    shuffle: typeof shuffle;
    similar: typeof similar;
    singleNumber: (nums: number[]) => number | undefined;
    stringToUint8Array: typeof stringToUint8Array;
    uint8ArrayToString: typeof uint8ArrayToString;
    union: typeof union;
};
